package com.miaozhen.controller;

import com.miaozhen.bean.AuditoriumBean;
import com.miaozhen.constants.Constants;
import com.miaozhen.util.FileUtil;
import com.miaozhen.util.JsonMapper;
import net.sf.json.JSON;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.multipart.FilePart;
import org.apache.commons.httpclient.methods.multipart.MultipartRequestEntity;
import org.apache.commons.httpclient.methods.multipart.Part;
import org.apache.commons.httpclient.methods.multipart.StringPart;
import org.quartz.SimpleTrigger;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description :
 * Created by liyongbo on 2025-03-13 16:38.
 */
@Controller
public class IndexController {

    @GetMapping("/")
    public String home(){
        return "index";
    }

    @PostMapping("/addAuditInfo")
    @ResponseBody
    public String addAuditInfo(String tmsId, String auditInfo){
        String code = "0";
        try{
            String path = FileUtil.getAudtiInfosPath();
            List<AuditoriumBean> list = (List<AuditoriumBean>) JsonMapper.getInstance().fromJson(auditInfo, List.class);

            Map map = new HashMap();
            map.put("tmsId",tmsId);
            map.put("audits",list);

            System.out.println(JsonMapper.getInstance().toJson(map));

            FileUtil.createPathIfNotExists(path);
            JsonMapper.getInstance().getMapper().writeValue(new File(path), map);

            code = "1";
        }catch (Exception e){
            e.printStackTrace();
        }
        return code;
    }

    @PostMapping("/getAuditInfos")
    @ResponseBody
    public String getAuditInfos(){
        String auditInfos = "";
        try{
            String path = FileUtil.getAudtiInfosPath();
            Map map = JsonMapper.getInstance().getMapper().readValue(new File(path), Map.class);
            auditInfos = JsonMapper.getInstance().toJson(map);
        }catch (Exception e){
            e.printStackTrace();
        }
        return auditInfos;
    }

}
