/**
 * 
 */
package com.miaozhen.device.response;

import com.pythagorastech.tms.device.dcserver.response.Response;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Kamil
 * 
 */
public class ListResponse extends Response {

	Logger log = LoggerFactory.getLogger(getClass());
	protected List<String> list;

	public ListResponse(String string, final String element) throws Exception {
		super(string);
		handler = new DefaultHandler() {
			private String tag = null;
			private StringBuilder sb = new StringBuilder();

			@Override
			public void startElement(String uri, String localName,
					String qName, Attributes attributes) throws SAXException {
				if (qName.equals(element)) {
					tag = qName;
					sb = new StringBuilder();
				}
			}

			@Override
			public void endElement(String uri, String localName, String qName)
					throws SAXException {
				if (qName.equals(element)) {
					tag = null;
					list.add(sb.toString());
				}
			}

			@Override
			public void characters(char[] ch, int start, int length)
					throws SAXException {
				if (tag != null && tag.equals(element)) {
					sb.append(new String(ch, start, length));
				}
			}
		};
		try {
			list = new ArrayList<String>();
			parser = SAXParserFactory.newInstance().newSAXParser();
			parser.parse(new InputSource(new StringReader(string)), handler);
		} catch (ParserConfigurationException e) {
			log.info("1====="+e.toString());
			throw new Exception("ParserConfigurationException", e);
		} catch (SAXException e) {
			log.info("2====="+e.toString());
			throw new Exception("SAXException", e);
		} catch (IOException e) {
			log.info("3====="+e.toString());
			throw new Exception("IOException", e);
		} finally {
			handler = null;
			parser = null;
		}
	}

	public List<String> getList() {
		return list;
	}
}
