package com.miaozhen.device.response;

import com.pythagorastech.tms.device.dcserver.response.Response;
import com.pythagorastech.tms.device.dcserver.smi.Schedule;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import java.io.IOException;
import java.io.StringReader;


public class ScheduleResponse extends Response {
	protected Schedule schedule;

	public ScheduleResponse(String string) throws Exception {
		super(string);
		handler = new DefaultHandler() {
			private String tag = null;
			private String show_uuid; 
			private String iso_date_time; 
			
			@Override
			public void startElement(String uri, String localName,
					String qName, Attributes attributes) throws SAXException {
				if (qName.equals("schedule")) {
					show_uuid = attributes.getValue("show_uuid");
					iso_date_time = attributes.getValue("iso_date_time");
					tag = qName;
				}
			}

			@Override
			public void endElement(String uri, String localName, String qName)
					throws SAXException {
				if (qName.equals("schedule")) {
					tag = null;
				}
			}

			@Override
			public void characters(char[] ch, int start, int length)
					throws SAXException {
				if (tag != null && tag.equals("schedule")) {
					String uuid = new String(ch, start, length);
					schedule = new Schedule(uuid, show_uuid, iso_date_time);
				}
			}
		};
		try {
			parser = SAXParserFactory.newInstance().newSAXParser();
			parser.parse(new InputSource(new StringReader(string)), handler);
		} catch (ParserConfigurationException e) {
			//logger.error(e.toString());
			throw new Exception("ParserConfigurationException", e);
		} catch (SAXException e) {
			//logger.error(e.toString());
			throw new Exception("SAXException", e);
		} catch (IOException e) {
			//logger.error(e.toString());
			throw new Exception("IOException", e);
		} finally {
			handler = null;
			parser = null;
		}
	}

	public Schedule getSchedule() {
		return schedule;
	}

}
