package com.miaozhen.device.response;

import com.pythagorastech.tms.device.dcserver.response.Response;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import java.io.IOException;
import java.io.StringReader;

public class SchedulerStatusResponse extends Response {
	protected boolean scheduler_status;

	public SchedulerStatusResponse(String string) throws Exception {
		super(string);
		handler = new DefaultHandler() {
			@Override
			public void startElement(String uri, String localName,
					String qName, Attributes attributes) throws SAXException {
				if (qName.equals("status")) {
					scheduler_status = (attributes.getValue("enabled")
							.equals("true"));
				}
			}
		};
		try {
			parser = SAXParserFactory.newInstance().newSAXParser();
			parser.parse(new InputSource(new StringReader(string)), handler);
		} catch (ParserConfigurationException e) {
			//logger.error(e.toString());
			throw new Exception("ParserConfigurationException", e);
		} catch (SAXException e) {
			//logger.error(e.toString());
			throw new Exception("SAXException", e);
		} catch (IOException e) {
			//logger.error(e.toString());
			throw new Exception("IOException", e);
		} finally {
			handler = null;
			parser = null;
		}
	}

	public boolean getSchedulerStatus() {
		return scheduler_status;
	}
}
