package com.miaozhen.device.response;

import com.pythagorastech.tms.device.dcserver.smi.IngestStatus;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import java.io.IOException;
import java.io.StringReader;


public class SonyIngestStatusResponse {
	protected IngestStatus ingestStatus = new IngestStatus();
	protected DefaultHandler handler;
	protected SAXParser parser;

	public SonyIngestStatusResponse(String string) throws Exception {
		handler = new DefaultHandler() {
			private String tag = null;

			@Override
			public void startElement(String uri, String localName,
					String qName, Attributes attributes) throws SAXException {
				if (qName.equals("CompletionStatus")
						|| qName.equals("PercentCompleted")
						|| qName.equals("ImportPath")
						|| qName.equals("InProgress")) {
					tag = qName;
				}
			}

			@Override
			public void endElement(String uri, String localName, String qName)
					throws SAXException {
				if (qName.equals("CompletionStatus")
						|| qName.equals("PercentCompleted")
						|| qName.equals("ImportPath")
						|| qName.equals("InProgress")) {
					tag = null;
				}
			}

			@Override
			public void characters(char[] ch, int start, int length)
					throws SAXException {
				if (tag != null && tag.equals("InProgress")) {
					String status = new String(ch, start, length);
					if (status.equals("true"))
						ingestStatus.setStatus(IngestStatus.STATUS_RUNNING);
					else if (status.equals("false"))
						ingestStatus.setStatus(IngestStatus.STATUS_STOPPED);
					else
						ingestStatus.setStatus(IngestStatus.STATUS_QUEUED);
				} else if (tag != null && tag.equals("PercentCompleted")) {
					ingestStatus.setPercent(Integer.parseInt(new String(ch,
							start, length)));
				} else if (tag != null && tag.equals("ImportPath")) {
					String importPath = new String(ch, start, length);
					importPath = importPath.replace("%3A%2F", "://").replace(
							"%2F", "/");
					importPath = importPath.replace("%2F", "/");
					ingestStatus.setDescription(importPath);
				}
			}
		};
		try {
			parser = SAXParserFactory.newInstance().newSAXParser();
			parser.parse(new InputSource(new StringReader(string)), handler);
		} catch (ParserConfigurationException e) {
			throw new Exception("ParserConfigurationException", e);
		} catch (SAXException e) {
			throw new Exception("SAXException", e);
		} catch (IOException e) {
			throw new Exception("IOException", e);
		} finally {
			handler = null;
			parser = null;
		}
	}

	public IngestStatus getIngestStatus() {
		return ingestStatus;
	}
}