package com.miaozhen.device.response;

import com.pythagorastech.tms.device.dcserver.response.Response;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import java.io.IOException;
import java.io.StringReader;

public class StorageInfoResponse extends Response {
	protected String total_space = "0";
	protected String free_space = "0";

	public StorageInfoResponse(String string) throws Exception {
		super(string);
		handler = new DefaultHandler() {
			@Override
			public void startElement(String uri, String localName,
					String qName, Attributes attributes) throws SAXException {
				if (qName.equals("storage")) {
					total_space = attributes.getValue("total_space");
					free_space = attributes.getValue("free_space");
				}
			}
		};
		try {
			parser = SAXParserFactory.newInstance().newSAXParser();
			parser.parse(new InputSource(new StringReader(string)), handler);
		} catch (ParserConfigurationException e) {
			//logger.error(e.toString());
			throw new Exception("ParserConfigurationException", e);
		} catch (SAXException e) {
			//logger.error(e.toString());
			throw new Exception("SAXException", e);
		} catch (IOException e) {
			//logger.error(e.toString());
			throw new Exception("IOException", e);
		} finally {
			handler = null;
			parser = null;
		}
	}

	public String getTotalSpace() {
		return total_space;
	}

	public String getFreeSpace() {
		return free_space;
	}
}
