package com.miaozhen.device.support.christienew.contentmanger;

import com.miaozhen.device.support.christienew.basecmd.BaseParamUUIDNoResultCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;


public class DeleteContentTMSNew extends BaseParamUUIDNoResultCmdTMSNew {

	private static short objid=42;
	private String UUID;
	public DeleteContentTMSNew(Socket socket, String host, int tcpPort, String UUID)
			throws IOException {
		super(socket, host, tcpPort, objid, UUID);
		this.UUID = UUID.replaceAll("urn:uuid:", "");
	}

	public DeleteContentTMSNew(Socket socket, String UUID) throws IOException {
		super(socket, objid, UUID);
		this.UUID = UUID.replaceAll("urn:uuid:", "");
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, this.UUID));
		return messageData.getElementsData();
	}
	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "UUID not found";
			break;
		case 2:
			errorMsg = "Operation not permitted. Content is currently loaded.";
			break;
		case 3:
			errorMsg = "KDM in use";
		}

		return errorMsg;
	}
}
