package com.miaozhen.device.support.christienew.contentmanger;

import com.christie.dcinema.xml.listcontent.CPL;
import com.christie.dcinema.xml.listcontent.Content;
import com.miaozhen.device.support.christienew.basecmd.ListContentTMSNew;
import org.crifst.smi.christie.contentmanagement.CplInfo;

import java.io.IOException;
import java.net.Socket;

public class GetCplInfoTMSNew extends ListContentTMSNew {
	private String cplUUID;
	protected CplInfo cplInfo = new CplInfo();

	public GetCplInfoTMSNew(Socket socket, String host, int tcpPort, String cplUUID)
			throws IOException {
		super(socket, host, tcpPort, 1);
		this.cplUUID = cplUUID;
	}

	public GetCplInfoTMSNew(Socket socket, String cplUUID) throws IOException {
		super(socket, 1);
		this.cplUUID = cplUUID;
	}

	protected String getResult(Content content) {
		for (CPL cpl : content.getCPL()) {
			if (cpl.getId().equals(this.cplUUID)||("urn:uuid:"+cpl.getId()).equals(this.cplUUID)) {
				this.cplInfo.setCplUUID(this.cplUUID);
				this.cplInfo.setCplName(cpl.getName());
				this.cplInfo.setComplete(cpl.isIsComplete());
				this.cplInfo.setEncrypted(cpl.isIsEncrypted());
				this.cplInfo.setKeyAvaliable(cpl.isIsKeyAvaliable());
				this.cplInfo.setDuration(cpl.getDuration());
				this.cplInfo.setValidFrom(cpl.getValidFrom());
				this.cplInfo.setValidTo(cpl.getValidTo());
				break;
			}
		}
		return null;
	}

	public CplInfo getCplInfo() {
		return this.cplInfo;
	}
}
