package com.miaozhen.device.support.christienew.contentmanger;

import com.miaozhen.device.support.christienew.basecmd.BaseParamUUIDCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;


public class GetCplTMSNew extends BaseParamUUIDCmdTMSNew {

	static short objid=58;
	private String UUID;
	public GetCplTMSNew(Socket socket, String host, int tcpPort, String cplUUID)
			throws IOException {
		super(socket, host, tcpPort, objid, cplUUID);
		this.UUID = cplUUID;
	}

	public GetCplTMSNew(Socket socket, String cplUUID) throws IOException {
		super(socket, objid, cplUUID);
		this.UUID = cplUUID;
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, this.UUID));
		return messageData.getElementsData();
	}
	protected String getResult(byte[] data) {
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(5));

		String cpl = element.getValue();
		cpl = cpl.replace("&", "&amp;");
		cpl = cpl.replace("\"", "&quot;");
		cpl = cpl.replace("<", "&lt;");
		cpl = cpl.replace(">", "&gt;");

		String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n";
		xml = xml + "\t<response_text>" + cpl + "</response_text>\n";
		xml = xml + "</response>";
		return xml;
	}

	protected String getErrorMsg(int errorCode) {
		if (errorCode == 1) {
			return "UUID not found";
		}
		return "Can not get cpl.";
	}

}
