package com.miaozhen.device.support.christienew.contentmanger;

import com.christie.dcinema.xml.listcontent.Content;
import com.miaozhen.device.support.smi.DeviceConstants;
import org.apache.commons.lang.StringUtils;

import java.io.IOException;
import java.net.Socket;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ValidateCplTMSNew extends GetCplInfoTMSNew {

	private boolean valid = false;
	private String errorMsg;
    private Date playTime;

	public ValidateCplTMSNew(Socket socket, String cplUUID, Date playTime) throws IOException {
		super(socket, cplUUID);
        this.playTime = playTime;
	}

	protected String getResult(Content content) {
		super.getResult(content);
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
		try {
            if(StringUtils.isBlank(this.cplInfo.getCplUUID())){
                this.valid = false;
                this.errorMsg = DeviceConstants.SPL_MISS_CPL;
            }else{
                if(playTime == null){
                    this.valid = this.cplInfo.isComplete();
                }else {
                    this.valid = ((this.cplInfo.isComplete()) && (((!(this.cplInfo
                            .isEncrypted())) || ((this.cplInfo.isKeyAvaliable())
                            && (format.parse(this.cplInfo.getValidFrom()).before(playTime)) && (format
                            .parse(this.cplInfo.getValidTo()).after(playTime))))));
                    if (!(this.valid))
                        if (!(this.cplInfo.isComplete()))
                            this.errorMsg = this.cplInfo.getCplUUID()+ DeviceConstants.CPL_MISS_ASSET;
                        else if ((this.cplInfo.isEncrypted())
                                && (!(this.cplInfo.isKeyAvaliable())))
                            this.errorMsg = DeviceConstants.CPL_MISS_KDM;
                        else if ((this.cplInfo.isEncrypted())
                                && (((format.parse(this.cplInfo.getValidFrom())
                                        .after(playTime)) || (format.parse(this.cplInfo
                                        .getValidTo()).before(playTime)))))
                            this.errorMsg = DeviceConstants.EXPIRED_FUTUTE_KDM;
                }
            }
		} catch (ParseException e) {
            this.errorMsg = DeviceConstants.VALIDATE_EXCEPTION;
			e.printStackTrace();
		}
		if (this.valid) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		}
		return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
				+ this.errorMsg + "</error>\n</response>";
	}

	public boolean isValid() {
		return this.valid;
	}

	public String getErrorMsg() {
		return this.errorMsg;
	}
	public static void main(String[] args) {}
}