package com.miaozhen.device.support.christienew.licensemanager;

import com.miaozhen.device.support.christienew.basecmd.BaseParamUUIDCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;


public class GetKdmTMSNew extends BaseParamUUIDCmdTMSNew {

	private static short objid=59;
	private String UUID;
	public GetKdmTMSNew(Socket socket, String host, int tcpPort, String cplUUID) throws IOException {
		super(socket, host, tcpPort, objid, cplUUID.replaceAll("urn:uuid:", ""));
		String str="urn:uuid:"+cplUUID.replaceAll("urn:uuid:", "");
		this.UUID=cplUUID.replaceAll("urn:uuid:", "");
	}

	public GetKdmTMSNew(Socket socket, String cplUUID) throws IOException {
		super(socket, objid, cplUUID.replaceAll("urn:uuid:", ""));
		String str="urn:uuid:"+cplUUID.replaceAll("urn:uuid:", "");
		this.UUID=cplUUID.replaceAll("urn:uuid:", "");
	}
	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, this.UUID));
		return messageData.getElementsData();
	}
	
	protected String getResult(byte[] data) {
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(5));

		String kdm = element.getValue();
		kdm = kdm.replace("&", "&amp;");
		kdm = kdm.replace("\"", "&quot;");
		kdm = kdm.replace("<", "&lt;");
		kdm = kdm.replace(">", "&gt;");

		String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n";
		xml = xml + "\t<response_text>" + kdm + "</response_text>\n";
		xml = xml + "</response>";
		return xml;
	}

	protected String getErrorMsg(int errorCode) {
		if (errorCode == 1) {
			return "UUID not found";
		}
		return "Can not get kdm.";
	}
}
