package com.miaozhen.device.support.christienew.showmanagement;

import com.miaozhen.device.support.christienew.basecmd.BaseChristieSeries2SocketCmdTMSNew;
import com.miaozhen.device.support.christienew.data.*;

import java.io.IOException;
import java.net.Socket;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.UUID;

public class AddScheduleItemTMSNew extends BaseChristieSeries2SocketCmdTMSNew {

	private String dateTime;
	private String showUUID;
	private String scheduleId;
	private String scheduleTitle;


	public AddScheduleItemTMSNew(Socket socket, String dateTime, String showUUID, String scheduleTitle)
			throws IOException {
		super(socket, (short)204);
		this.dateTime = dateTime;
		this.showUUID = showUUID;
		this.scheduleTitle = scheduleTitle;
	}

	
	protected byte[] createCmdData() throws ParseException {
		this.scheduleId = UUID.randomUUID().toString();
		
		LMessageData messageData = new LMessageData();
		
		SimpleDateFormat formatterall =new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
		Date date = formatterall.parse(dateTime);

		SimpleDateFormat formatter1 =new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		SimpleDateFormat formatter2 =new SimpleDateFormat("yyyy-MM-dd");
		String st = showUUID.replaceAll("urn:uuid:", "playlist_");
		String str1=formatter1.format(date);
		String str2=formatter2.format(date);
		
		messageData.addElement(new LStringElement(0,str1));
		messageData.addElement(new LStringElement(1,str2));
		messageData.addElement(new LStringElement(2,""));
		
		messageData.addElement(new LINT8Element(3,0));
		messageData.addElement(new LINT8Element(4,0));
		messageData.addElement(new LINT8Element(5,0));
		
		messageData.addElement(new LStringElement(6, "Playlists"));
		
		messageData.addElement(new LUTF8StringElement(7, scheduleTitle));
		messageData.addElement(new LStringElement(8, st));
		messageData.addElement(new LUTF8StringElement(9,"Smart TMS Create"));
		messageData.addElement(new LBooleanElement(10,true));

		return messageData.getElementsData();
	}
	
	
	protected String getResult(byte[] data) {
		return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n\t<schedule_uuid>urn:uuid:"
				+ this.scheduleId + "</schedule_uuid>" + "\n</response>";
	}

	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "Malformed XML";
			break;
		case 2:
			errorMsg = "Invalid Time";
			break;
		case 3:
			errorMsg = "Duplicate ID";
		}

		return errorMsg;
	}

}
