package com.miaozhen.device.support.christienew.showmanagement;

import com.miaozhen.device.support.christienew.basecmd.BaseParamUUIDCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import com.miaozhen.device.support.christienew.data.xmljaxb.LSchedule;
import com.miaozhen.device.support.christienew.data.xmljaxb.LScheduleItem;
import com.miaozhen.device.util.XMLUtil;

import java.io.IOException;
import java.net.Socket;
import java.util.List;

public class GetScheduleByIDTMSNew extends BaseParamUUIDCmdTMSNew {

	//149
	public GetScheduleByIDTMSNew(Socket socket, String host, int tcpPort, String UUID)
			throws IOException {
		super(socket, host, tcpPort, (short)201, UUID.replaceAll("urn:uuid:", ""));
	}

	public GetScheduleByIDTMSNew(Socket socket, String UUID) throws IOException {
		super(socket, (short)201, UUID.replaceAll("urn:uuid:", ""));
	}

	protected String getResult(byte[] data) {
		String result = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >";
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(0));

		String xml = element.getValue();

		try {
			xml=xml.replaceAll("<UUID>", "<ID>").replaceAll("</UUID>", "</ID>");
			xml=xml.replaceAll("<LocalStartTime>", "<DateTime>").replaceAll("</LocalStartTime>", "</DateTime>");
			xml=xml.replaceAll("<ActionId>", "<ContentID>").replaceAll("</ActionId>", "</ContentID>");
			LSchedule schedules=(LSchedule) XMLUtil.convertXmlStrToObject(LSchedule.class, xml);
			List<LScheduleItem> items =  schedules.getLScheduleItems();
			LScheduleItem item = new LScheduleItem();
			if( items != null && items.size() != 0){
				item = items.get(0);
			}
			String showId = item.getContentID().replaceAll("playlist_",
					"urn:uuid:");
			String isoDateTime=item.getDateTime();
			String scheduleId = "urn:uuid:" + item.getID();
			result = result + "\n\t<schedule show_uuid=\"" + showId
					+ "\" iso_date_time=\"" + isoDateTime + "\" >"
					+ scheduleId + "</schedule>";
		} catch (Exception e) {
			e.printStackTrace();
		}

		result = result + "\n</response>";
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		return "Invalid Schedule ID";
	}
}
