package com.miaozhen.device.support.christienew.showmanagement;

import com.miaozhen.device.support.christienew.basecmd.BaseChristieSeries2SocketCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import com.miaozhen.device.support.christienew.data.xmljaxb.LSchedule;
import com.miaozhen.device.support.christienew.data.xmljaxb.LScheduleItem;
import com.miaozhen.device.util.XMLUtil;

import java.io.IOException;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class GetScheduleTMSNew  extends BaseChristieSeries2SocketCmdTMSNew {
	public GetScheduleTMSNew(Socket socket, String host, int tcpPort) throws IOException {
		//140
		super(socket, host, tcpPort, (short)200);
	}

	public GetScheduleTMSNew(Socket socket) throws IOException {
		super(socket, (short)200);
	}

	public static Date getNextHour(Date date, int hour) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.HOUR_OF_DAY, hour);
        date = calendar.getTime();
        return date;
    }
	protected byte[] createCmdData() {
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date currentTime=new Date();
		String dateString = formatter.format(currentTime);
		Date after=getNextHour(currentTime,48);
		String dateString1 = formatter.format(after);
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(0, dateString));
		messageData.addElement(new LStringElement(1, dateString1));
		return messageData.getElementsData();
		//return new byte[0];
	}

	protected String getResult(byte[] data) {
		String result = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >";
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(0));

		String xml = element.getValue();
		xml=xml.replaceAll("<UUID>", "<ID>").replaceAll("</UUID>", "</ID>");
		xml=xml.replaceAll("<LocalStartTime>", "<DateTime>").replaceAll("</LocalStartTime>", "</DateTime>");
		xml=xml.replaceAll("<ActionId>", "<ContentID>").replaceAll("</ActionId>", "</ContentID>");
		LSchedule schedules=(LSchedule) XMLUtil.convertXmlStrToObject(LSchedule.class, xml);

		 try {
			for (LScheduleItem item : schedules.getLScheduleItems()) {
				String showId = item.getContentID().replaceAll("playlist_",
						"urn:uuid:");
				String isoDateTime=item.getDateTime();
				SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
				Date date = formatter.parse(isoDateTime);
				isoDateTime = sdf.format(date);
				String scheduleId = "urn:uuid:" + item.getID();
				result = result + "\n\t<schedule show_uuid=\"" + showId
						+ "\" iso_date_time=\"" + isoDateTime + "\" >"
						+ scheduleId + "</schedule>";
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		result = result + "\n</response>";
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		return "Can not get schedule list.";
	}

}