package com.miaozhen.device.support.christienew.showmanagement;

import com.miaozhen.device.support.christienew.basecmd.BaseChristieSeries2SocketCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LBooleanElement;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LXMLElement;

import java.io.IOException;
import java.net.Socket;


public class SetPlaylistTMSNew extends BaseChristieSeries2SocketCmdTMSNew {

	private String spl;

	public SetPlaylistTMSNew(Socket socket, String host, int tcpPort, String spl) throws IOException {
		super(socket, host, tcpPort, (short)44);
		this.spl = spl;
	}

	public SetPlaylistTMSNew(Socket socket, String spl) throws IOException {
		super(socket, (short)44);
		this.spl = spl;
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		
		
		String str1="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
		"<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" elementFormDefault=\"qualified\">" +
        "<CDSPlaylist>\n" +
        "    <Id>playlist_d29de7de-ffc3-4f1a-b068-787bfc3e828b</Id>\n" +
        "    <AnnotationText>test1</AnnotationText>\n" +
        "    <CreationDate>2017-09-30T15:57:15.635000-00:00</CreationDate>\n" +
        "    <Creator>None</Creator>\n" +
        "    <Color>#000000</Color>\n" +
        "    <TotalRunLength>6702000</TotalRunLength>\n" +
        "    <EntryList>\n" +
        "        <Entry>\n" +
        "            <Id>506df884-5240-480c-a49e-6b3f641eb28a</Id>\n" +
        "            <AnnotationText>WangPaiBaoBiao-2D_235_JP_51_YZ_112M_0905_OV</AnnotationText>\n" +
        "            <CompositionId>c7cee89b-e29f-4102-a30f-b70c837c0c3b</CompositionId>\n" +
        "            <Duration>6702000</Duration>\n" +
        "            <Tag></Tag>\n" +
        "            <AutomationCueList/>\n" +
        "        </Entry>\n" +
        "    </EntryList>\n" +
        "</CDSPlaylist>";
//
//		String str="<?xml version=\"1.0\"?>"+
//					"<CDSPlaylist>"+
//					"<Id>playlist_223bb144-e20d-4b74-8a2d-657b3f505796</Id>"+
//					"<AnnotationText>[TMS]:EN_Alice-In-Won3D_T4_1505905705291</AnnotationText>"+
//					"<CreationDate>2017-09-20T19:08:25.296+08:00</CreationDate>"+
//					"<Creator>Smart TMS3 Orion</Creator>"+
//					"<Color>#000000</Color>"+
//					"<TotalRunLength>100000</TotalRunLength>"+
//					"<EntryList>"+
//					"<Entry>"+
//					"<Id>68b1e41d-9f6a-4951-96dd-e97d65cf6b81</Id>"+
//					"<AnnotationText>Alice-In-Won3D_TSR-1-2D_S_EN-XX_US-GB_51_2K_DI_20090707_TDC</AnnotationText>"+
//					"<CompositionId>04cbb7da-1bab-489e-90b6-4f027ebe48c0</CompositionId>"+
//					"<Duration>100000</Duration>"+
//					"<Tag></Tag>"+
//					"<AutomationCueList/>"+
//					"</Entry>"+
//					"</EntryList>"+
//					"</CDSPlaylist>";
		String spl_fix=spl.replaceAll("<CompositionId>urn:uuid:", "<CompositionId>");
		messageData.addElement(new LXMLElement(0, spl_fix));
		messageData.addElement(new LBooleanElement(1,false));
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
	}

	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "Malformed Playlist";
			break;
		case 2:
			errorMsg = "General Error Saving Playlist Review Logs";
			break;
		case 3:
			errorMsg = "No primary drive configured or available.";
			break;
		case 4:
			errorMsg = "Playlist is currently loaded.";
		}

		return errorMsg;
	}

}
