package com.miaozhen.device.support.christienew.showmanagement;

import com.miaozhen.device.support.christienew.contentmanger.ValidateCplTMSNew;
import org.crifst.smi.christie.contentmanagement.CplInfo;

import java.net.Socket;
import java.util.Date;


public class ValidateSplTMSNew {
	private Socket socket;
	private String UUID;
    private Date playTime;

	public ValidateSplTMSNew(Socket socket, String UUID, Date playTime) {
		this.socket = socket;
		this.UUID = UUID;
        this.playTime = playTime;
	}

	public String getResponse() {
    boolean valid = true;
    String errorMsg = "Missing Assets.";
    try {
      GetPlaylistTMSNew cmd = new GetPlaylistTMSNew(this.socket, this.UUID);
      cmd.execute();
      for (CplInfo cpl : cmd.getCplList()) {
        ValidateCplTMSNew cmd1 = new ValidateCplTMSNew(this.socket, cpl.getCplUUID(), playTime);
        cmd1.execute();
        valid &= cmd1.isValid();
        if (!(valid)) {
          errorMsg = cpl.getCplName() + " " + cmd1.getErrorMsg();
          break ;
        }
      }
    } catch (Exception e) {
      valid = false;
      e.printStackTrace();
    }
    if (valid) {
      return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
    }
    return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>" + 
      errorMsg + "</error>\n</response>";
  }
}
