package com.miaozhen.device.support.christienew.transfermanagerment;


import com.miaozhen.device.support.christienew.basecmd.BaseNoResultCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;


public class CancelIngestTMSNew extends BaseNoResultCmdTMSNew {
	private String UUID;

	private static short objid=55;
	public CancelIngestTMSNew(Socket socket, String host, int tcpPort, String UUID)
			throws IOException {
		super(socket, host, tcpPort, objid);
		this.UUID = UUID;
	}

	public CancelIngestTMSNew(Socket socket, String UUID) throws IOException {
		super(socket, objid);
		this.UUID = UUID;
	}

	protected byte[] createCmdData() {
		byte[] result = (byte[]) null;
		try {
			GetIngestStatusTMSNew cmd = new GetIngestStatusTMSNew(this.socket, this.UUID);
			cmd.execute();
			String id_next=cmd.getId_next();
			if (id_next != null) {
				LMessageData messageData = new LMessageData();
				messageData.addElement(new LStringElement(1, id_next));
				result = messageData.getElementsData();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		String result = "Send ingest command failed.";
		switch (errorCode) {
		case 1:
			result = "Ingest ID not found";
			break;
		case 2:
			result = "Ingest ID not canceled";
		}
		return result;
	}

}
