package com.miaozhen.device.support.christienew.transfermanagerment;


import com.miaozhen.device.support.christienew.basecmd.BaseNoParamCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LElement;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import com.miaozhen.device.support.christienew.data.xmljaxb.IngestStatus;
import com.miaozhen.device.support.christienew.data.xmljaxb.IngestStatusItem;
import com.miaozhen.device.util.XMLUtil;

import java.io.IOException;
import java.net.Socket;

public class GetIngestStatusTMSNew extends BaseNoParamCmdTMSNew {

    public static enum SmiTransportStateTypeEnum {
		QUEUED, RUNNING, FINISHED, ERROR;

		public String value() {
			return name();
		}

		public static SmiTransportStateTypeEnum fromValue(String v) {
			return valueOf(v);
		}
	}

	private String UUID;
	private Integer id;
	private String id_next;
	

	public String getId_next() {
		return id_next;
	}

	public void setId_next(String id_next) {
		this.id_next = id_next;
	}

	public GetIngestStatusTMSNew(Socket socket, String host, int tcpPort,
			String UUID) throws IOException {
		super(socket, host, tcpPort, (short) 54);
		this.UUID = UUID;
	}

	public GetIngestStatusTMSNew(Socket socket, String UUID) throws IOException {
		super(socket, (short) 54);
		this.UUID = UUID;
	}

	protected String getResult(byte[] data) {
		String result = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n\t<ingest_status>\n\t\t<status>ERROR</status>\n\t\t<percent>0</percent>\n\t\t<description>UUID NOT FOUND</description>\n\t</ingest_status>\n</response>";

		LMessageData messageData = new LMessageData(data);
		LElement el=messageData.getElementByKey(5);
		if(el==null){
			el=messageData.getElementByKey(0);
		}
		LStringElement state = new LStringElement(el);
		String xml = state.getValue();
		try {
			IngestStatus ingestStatus = (IngestStatus) XMLUtil.convertXmlStrToObject(IngestStatus.class,xml);
			for (IngestStatusItem statusItem : ingestStatus
					.getItemList()) {
				if (statusItem.getIngestTitle().equals(this.UUID)) {
					//this.id = Integer.valueOf(statusItem.getId());
					String str = statusItem.getIngestID();
//					str=str.replace("{","");
//					str=str.replaceAll("}","");
					this.id_next=str;
					String description = "";
					String ingestState = SmiTransportStateTypeEnum.ERROR.name();
					switch (statusItem.getIngestState()) {
					case 0:
						ingestState = SmiTransportStateTypeEnum.RUNNING.name();
						break;
					case 1:
						ingestState = SmiTransportStateTypeEnum.FINISHED.name();
						break;
					case 3:
						ingestState = SmiTransportStateTypeEnum.QUEUED.name();
						break;
					case 2:
						description = "Cancelled";
						break;
					case 4:
						ingestState = SmiTransportStateTypeEnum.ERROR.name();
						break;
					}

					String percent = (statusItem.getTotalbytes() > 0L) ? String
							.valueOf(statusItem.getIngestedbytes() * 100L
									/ statusItem.getTotalbytes()) : "0";
					result = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n\t<ingest_status>";
					result = result + "\n\t\t<status>" + ingestState
							+ "</status>";
					result = result + "\n\t\t<percent>" + percent
							+ "</percent>";
					result = result + "\n\t\t<description>" + description
							+ "</description>";
					result = result + "\n\t</ingest_status>\n</response>";
					break;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		return "Can not ingest status.";
	}

	public Integer getId() {
		return this.id;
	}
}
