package com.miaozhen.device.support.christienew.transfermanagerment;

import com.miaozhen.device.support.christienew.basecmd.BaseNoParamCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LXMLElement;

import java.io.IOException;
import java.net.Socket;


public class IngestKDMTMSNew extends BaseNoParamCmdTMSNew {

	private String kdm;

	private static short objid=57;
	public IngestKDMTMSNew(Socket socket, String host, int tcpPort, String kdm) throws IOException {
		super(socket,host, tcpPort, objid);
		this.kdm = kdm;
	}

	public IngestKDMTMSNew(Socket socket, String kdm) throws IOException {
		super(socket, objid);
		this.kdm = kdm;
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LXMLElement(1, this.kdm));
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		return "ok";
	}
	protected String getErrorMsg(int errorCode) {
		String result = "Send ingest command failed.";
		switch (errorCode) {
		case 1:
			result = "Invalid XML";
			break;
		case 2:
			result = "Invalid KDM";
			break;
		case 3:
			result = "Primary content drive is currently not available or configured";
		}
		return result;
	}
}
