package com.miaozhen.device.support.christienew.transfermanagerment;

import com.miaozhen.device.support.christienew.basecmd.BaseChristieSeries2SocketCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LINT32Element;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;
import java.util.UUID;


public class IngestRemoteContentTMSNew extends BaseChristieSeries2SocketCmdTMSNew {

	private String ipaddr;
	private String user;
	private String password;
	private String cpl_path;
	private String ingest_uuid;
	private String cpl_UUID;

	private static short objid=168;
	public IngestRemoteContentTMSNew(Socket socket, String host, int tcpPort, String ipaddr,
			String user, String password, String cpl_UUID, String cpl_path)
			throws IOException {
		super(socket,host, tcpPort, objid);
		this.ipaddr = ipaddr;
		this.user = user;
		this.password = password;
		this.cpl_path = cpl_path;
		this.cpl_UUID = cpl_UUID;
	}

	protected byte[] createCmdData() {

		//this.ingest_uuid = "urn:uuid:" + UUID.randomUUID().toString();
		this.ingest_uuid = UUID.randomUUID().toString();
		/*if(!StringUtils.isEmpty(this.cpl_path)){
			this.ingest_uuid = this.cpl_path.split(File.separator)[0];
		}*/
		//this.cpl_path="ZHUI-LONG_FTR_S_CMN-QMS_131M_51_2K_20170919_HXFILM_OV/PKL_828b3186-cd20-49d5-8ad0-0f3f4ea3547f.xml";
		
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, this.ipaddr));
		messageData.addElement(new LStringElement(2, this.user));
		messageData.addElement(new LStringElement(3, this.password));
		messageData.addElement(new LINT32Element(4, 6));
		
		messageData.addElement(new LStringElement(6, this.cpl_UUID));
		messageData.addElement(new LStringElement(7, this.ingest_uuid));
		
		/*messageData.addElement(new LStringElement(6, this.cpl_path));
		messageData.addElement(new LStringElement(7, this.ingest_uuid));*/
		messageData.addElement(new LINT32Element(8, 21));
		//发送传输命令之前，等待scan完成，这里使线程睡眠2秒
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<response status=\"OK\" version=\"2\" >\n\t<ingest_uuid>"
				+ this.ingest_uuid + "</ingest_uuid>" + "\n</response>";
	}

	protected String getErrorMsg(int errorCode) {
		String result = "Send ingest command failed.";
		switch (errorCode) {
		case 1:
			result = "Cannot conntect";
			break;
		case 2:
			result = "CPL not found";
			break;
		case 3:
			result = "Unknown Error";
		}
		return result;
	}


	/*public static void main(String[] args) {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, "127.0.0.1"));
		messageData.addElement(new LStringElement(2, "user"));
		messageData.addElement(new LStringElement(3, "pswd"));
		messageData.addElement(new LINT32Element(4, 6));

		messageData.addElement(new LStringElement(6, "cpluuid"));
		messageData.addElement(new LStringElement(7, "ingest_uuid"));

		*//*messageData.addElement(new LStringElement(6, this.cpl_path));
		messageData.addElement(new LStringElement(7, this.ingest_uuid));*//*
		messageData.addElement(new LINT32Element(8, 21));
		//发送传输命令之前，等待scan完成，这里使线程睡眠2秒
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println( messageData.getElementsData());
	}*/

}
