package com.miaozhen.device.support.christienew.transfermanagerment;

import com.miaozhen.device.support.christienew.basecmd.BaseChristieSeries2SocketCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LINT32Element;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;

public class ScanRemoteIngestiblesTMSNew extends BaseChristieSeries2SocketCmdTMSNew {


	private String ipaddr;
	private String user;
	private String password;
	

	private static short objid=166;
	public ScanRemoteIngestiblesTMSNew(Socket socket, String host, int tcpPort, String ipaddr,
			String user, String password)
			throws IOException {
		super(socket,host, tcpPort, objid);
		this.ipaddr = ipaddr;
		this.user = user;
		this.password = password;
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, this.ipaddr));
		messageData.addElement(new LStringElement(2, this.user));
		messageData.addElement(new LStringElement(3, this.password));
		messageData.addElement(new LINT32Element(4, 5));
		messageData.addElement(new LStringElement(6, "/"));
		messageData.addElement(new LINT32Element(7, 21));
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		return "ook";
	}

	protected String getErrorMsg(int errorCode) {
		String result = "Send ingest command failed.";
		switch (errorCode) {
		case 1:
			result = "Cannot conntect";
			break;
		case 2:
			result = "CPL not found";
			break;
		case 3:
			result = "Unknown Error";
		}
		return result;
	}



}
