package com.miaozhen.device.support.util;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * @Description :
 * Created by liyongbo on 2025-02-25 10:31.
 */
public class IMaxSocketUtil {

    public static ConcurrentHashMap<String,Socket> sockets = new ConcurrentHashMap<>();

    private static final Lock lock = new ReentrantLock();

    private IMaxSocketUtil() {}

    public static Socket getInstance(String ip,int port) {
        if (sockets.get(ip) == null) {
            lock.lock();
            try {
                if (sockets.get(ip) == null) {
                    Socket socket = new Socket();
                    SocketAddress socketAddress = new InetSocketAddress(ip, port); // 获取sockaddress对象
                    try {
                        socket.connect(socketAddress, 5 * 1000);
                        socket.setSoTimeout(10 * 1000);
                        sockets.put(ip, socket);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }finally {
                lock.unlock();
            }
        }
        return sockets.get(ip);
    }

    public static void close(String ip) {
        try {
            sockets.get(ip).close();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            sockets.put(ip,null);
        }
    }
}
