package com.miaozhen.util;


import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class StrUtil {

    public static final String replace(String strInput, String oldString, String newString) {
        if (strInput == null)
            return "";
        int i = 0;
        if ((i = strInput.indexOf(oldString, i)) >= 0) {
            char strInput2[] = strInput.toCharArray();
            char newString2[] = newString.toCharArray();
            int oLength = oldString.length();
            StringBuffer buf = new StringBuffer(strInput2.length);
            buf.append(strInput2, 0, i).append(newString2);
            i += oLength;
            int j;
            for (j = i; (i = strInput.indexOf(oldString, i)) > 0; j = i) {
                buf.append(strInput2, j, i - j).append(newString2);
                i += oLength;
            }

            buf.append(strInput2, j, strInput2.length - j);
            return buf.toString();
        } else {
            return strInput;
        }
    }

    public static String[] split(String strInput, String strCut) {
        if (strInput == null || strCut == null)
            return new String[0];
        StringBuffer strbufTemp = new StringBuffer(strInput);
        String strNew = new String();
        ArrayList<String> al = new ArrayList<String>();
        for (int i = 0; (i = (new String(strbufTemp)).indexOf(strCut)) != -1; ) {
            strNew = strbufTemp.substring(0, i);
            strbufTemp = strbufTemp.delete(0, i + strCut.length());
            al.add(strNew);
        }

        strNew = strbufTemp.toString();
        al.add(strNew);
        String rt[] = new String[al.size()];
        for (int i = 0; i < al.size(); i++)
            rt[i] = (String) al.get(i);

        return rt;
    }

    public static List<String> match(String reg, String source) {
        List<String> result = new ArrayList<String>();
        Matcher m = Pattern.compile(reg).matcher(source);
        while (m.find()) {
            String r = m.group(0);
            result.add(r);
        }
        return result;
    }

    public static boolean isEmpty(String str) {
        return str == null || str.trim().equals("");
    }

    public static boolean isNotEmpty(String str) {
        return !isEmpty(str);
    }

    public static String makeMD5(String password) {
        MessageDigest md;
        try {
            md = MessageDigest.getInstance("MD5");
            md.update(password.getBytes());
            String pwd = new BigInteger(1, md.digest()).toString(16);
            return pwd;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return password;
    }
    public static int getNumFromString(String str) {
        String regEx="[^0-9]";
        Pattern p = Pattern.compile(regEx);
        Matcher m = p.matcher(str);
        String repStr = m.replaceAll("").trim();
        if(repStr.length() > 0 ){
            return  Integer.valueOf(repStr);
        }
        return  0;
    }

    public static String inputStream2String(InputStream is) throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        int i = -1;
        while ((i = is.read()) != -1) {
            baos.write(i);
        }
        return baos.toString();
    }
    public static boolean isNumeric(String str){
        Pattern pattern = Pattern.compile("[0-9]*");
        return pattern.matcher(str).matches();
    }

    public static void main(String[] args) {

      String path = "test/DaHongBao2_FTR-2D-24_S_CMN-QMS_127M_51_2K_20241225_OV_3100151_20250110T1700_20250209T2359_2_bd.xml";

        String filename = path.substring(path.lastIndexOf("/")+1);
        String diskName = path.substring(0, path.lastIndexOf("/"));

        System.out.println(filename);
        System.out.println(diskName);

    }

    public static String subAudit(String distribute,String audit){
        distribute = (","+distribute+",").replace(","+audit+",", ",");
        if(",".equals(distribute)){
            distribute = "";
        }else{
            distribute=distribute.substring(1,distribute.length()-1);
        }
        return distribute;
    }

    public static String encodeURL(String url){
        String url2 = null;
        try {
            url2 = URLEncoder.encode(url,"utf-8");
            url2= url2.replaceAll("%3A",":");
            url2= url2.replaceAll("%2F","/");
            return url2;
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return url;
    }

    public static boolean isSkipDirContent(String dirName){
        if(dirName.startsWith(".")){
            return true;
        }
       if("lost+found".equals(dirName) || "KDMs".equals(dirName) || "databasebackup".equals(dirName) || "backup".equals(dirName)) {  //GDC 密钥盘KDMs  在片库目录
           return true;
       }

        return false;
    }

}
