package com.miaozhen.device.support.christienew.showmanagement;

import com.christie.dcinema.xml.automationconfig.Automation;
import com.miaozhen.device.support.christienew.basecmd.BaseNoParamCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LXMLElement;
import com.miaozhen.device.support.christienew.data.xmljaxb.AutomationScript;
import com.miaozhen.device.support.christienew.data.xmljaxb.AutomationScriptList;
import com.miaozhen.device.util.XMLUtil;
import org.crifst.smi.christie.xml.AbstractXmlObject;

import javax.xml.bind.JAXBException;
import java.io.IOException;
import java.net.Socket;

public class GetAutomationConfigTMSNew extends BaseNoParamCmdTMSNew {

	public GetAutomationConfigTMSNew(Socket socket) throws IOException {
		super(socket, (short)300);
	}

	protected String getResult(byte[] data) {
		String result = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >";
		LMessageData messageData = new LMessageData(data);
		LXMLElement element = new LXMLElement(
				messageData.getElementByKey(0));
		String xml = element.getValue();

		try {
			AutomationScriptList automationScriptList = (AutomationScriptList) XMLUtil.convertXmlStrToObject(AutomationScriptList.class, xml);
			for (AutomationScript marco : automationScriptList.getAutomationScripts())
				result = result + "\n\t<automation_label>" + marco.getName()
						+ "</automation_label>";
		} catch (Exception e) {
			e.printStackTrace();
		}
		result = result + "\n</response>";
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		return "Config file is empty or error when returning config file";
	}

	class AutomationConfigXmlObject extends AbstractXmlObject<Automation> {
		public AutomationConfigXmlObject(String paramString)
				throws JAXBException, IOException {
			super(paramString);
		}
	}
}
